diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatter.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatter.java
new file mode 100644
index 000000000..fe0c402e1
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatter.java
@@ -0,0 +1,148 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class WorldFeatureNetherScatter implements WorldFeatureInterface {
+    private static final int MAX_DOWN_SCAN = 96;
+    private static final int BONE_PILE_ON_ASH_RARE_ONE_IN = 8;
+    private static final int EMBER_FIRST_ROLL_SIDES = 4;
+    private static final int EMBER_FIRST_ROLL_THRESHOLD = 1;
+
+    private final TilePos scratchGround = new TilePos();
+    private final TilePos scratchPlace = new TilePos();
+    private final TilePos scratchProbe = new TilePos();
+    private final TilePos scratchNeighbor = new TilePos();
+
+    @Override
+    public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+        if (random.nextInt(EMBER_FIRST_ROLL_SIDES) >= EMBER_FIRST_ROLL_THRESHOLD) {
+            final Biome seedBiome = world.getBlockBiome(tilePos);
+            if (isOldWorldBiome(seedBiome)) {
+                if (this.tryPlaceEmberReplacingAsh(world, tilePos)) {
+                    return true;
+                }
+            }
+        }
+
+        final TilePos ground = this.scratchGround.set(tilePos.x(), tilePos.y(), tilePos.z());
+        int scanned = 0;
+        while (world.isAirBlock(ground) && ground.y() > 0 && scanned < MAX_DOWN_SCAN) {
+            ground.down();
+            scanned++;
+        }
+        if (ground.y() <= 0) { return false; }
+
+        final Block<?> surface = world.getBlockType(ground);
+
+        if (isRubyglassScatterForbiddenSurface(surface)) {
+            return false;
+        }
+
+        final TilePos placePos = this.scratchPlace.set(ground.x(), ground.y() + 1, ground.z());
+        if (!world.isAirBlock(placePos)) { return false; }
+
+        final Block<?> chosen = pickDecoration(world, random, placePos, surface);
+
+        if (chosen == Blocks.BOULDER_MAGMATIC && surface != Blocks.COBBLE_NETHERRACK && surface != Blocks.NETHERRACK) {
+            return false;
+        }
+        if (chosen == Blocks.BOULDER_SULFURIC && surface != Blocks.BRIMSAND && surface != Blocks.BRIMSTONE && surface != Blocks.BRIMTHAW) {
+            return false;
+        }
+        if (chosen == Blocks.BONE_PILE && isAshSurface(surface)) {
+            if (random.nextInt(BONE_PILE_ON_ASH_RARE_ONE_IN) != 0) {
+                return false;
+            }
+        }
+        if (!chosen.canStay(world, placePos)) { return false; }
+
+        world.setBlockType(placePos, chosen);
+        return true;
+    }
+
+    private static boolean isOldWorldBiome(final @Nullable Biome biome) {
+        return biome == Biomes.NETHER_OLD_WORLD || biome == Biomes.NETHER_OLD_WORLD_DESERT;
+    }
+
+    private static boolean isAshSurface(final @NotNull Block<?> surface) {
+        return surface == Blocks.BLOCK_ASH || surface == Blocks.LAYER_ASH;
+    }
+
+    private static boolean isRubyglassScatterForbiddenSurface(final @NotNull Block<?> surface) {
+        return surface == Blocks.RUBYGLASS_NODE
+                || surface == Blocks.RUBYGLASS_COLUMN
+                || surface == Blocks.RUBYGLASS_GROWTH;
+    }
+
+    private boolean tryPlaceEmberReplacingAsh(final @NotNull World world, final @NotNull TilePosc start) {
+        final int x = start.x();
+        final int z = start.z();
+        final TilePos probe = this.scratchProbe;
+
+        int scanned = 0;
+        for (int y = start.y(); y > 0 && scanned < MAX_DOWN_SCAN; y--, scanned++) {
+            probe.set(x, y, z);
+
+            if (world.getBlockType(probe) != Blocks.BLOCK_ASH) {
+                continue;
+            }
+
+            final TilePos above = this.scratchPlace.set(x, y + 1, z);
+            if (!world.isAirBlock(above)) {
+                continue;
+            }
+
+            if (!isOldWorldBiome(world.getBlockBiome(probe))) {
+                continue;
+            }
+
+            if (!this.isAshSurroundedByAsh(world, x, y, z)) {
+                continue;
+            }
+
+            world.setBlockType(probe, Blocks.EMBER);
+            if (Blocks.LAYER_ASH.canPlaceAt(world, above)) {
+                world.setBlockType(above, Blocks.LAYER_ASH);
+            }
+            return true;
+        }
+        return false;
+    }
+
+    private boolean isAshSurroundedByAsh(final @NotNull World world, final int ax, final int ay, final int az) {
+        final TilePos n = this.scratchNeighbor;
+        return world.getBlockType(n.set(ax + 1, ay, az)) == Blocks.BLOCK_ASH
+                && world.getBlockType(n.set(ax - 1, ay, az)) == Blocks.BLOCK_ASH
+                && world.getBlockType(n.set(ax, ay, az + 1)) == Blocks.BLOCK_ASH
+                && world.getBlockType(n.set(ax, ay, az - 1)) == Blocks.BLOCK_ASH;
+    }
+
+    private @NotNull Block<?> pickDecoration(final @NotNull World world, final @NotNull Random random,
+                                             final @NotNull TilePos placePos, final @NotNull Block<?> surface) {
+        if (surface == Blocks.OBSIDIAN) {
+            return Blocks.BONE_PILE;
+        }
+
+        final Biome biome = world.getBlockBiome(placePos);
+        if (biome == Biomes.NETHER_SULFUR_POOLS) {
+            return random.nextBoolean() ? Blocks.BONE_PILE : Blocks.BOULDER_SULFURIC;
+        }
+        if (biome == Biomes.NETHER_VOLCANIC_ISLANDS || biome == Biomes.NETHER_CRAG
+                || biome == Biomes.NETHER_CRYSTAL_PLAINS || biome == Biomes.NETHER_CRYSTAL_FOREST
+                || biome == Biomes.NETHER_SHELF) {
+            return random.nextBoolean() ? Blocks.BONE_PILE : Blocks.BOULDER_MAGMATIC;
+        }
+
+        return Blocks.BONE_PILE;
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherSpring.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherSpring.java
index b71f37b38..e5b7bf40d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherSpring.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherSpring.java
@@ -1,79 +1,65 @@
 package net.minecraft.core.world.generate.feature;
 
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class WorldFeatureNetherSpring extends WorldFeature
-{
-    private final int blockId;
-    @MethodParametersAnnotation(names = {"blockId"})
-    public WorldFeatureNetherSpring(int blockId)
-    {
-        this.blockId = blockId;
-    }
+public class WorldFeatureNetherSpring implements WorldFeatureInterface {
+	private final int blockId;
 
-    @Override
-	public boolean place(World world, Random random, int x, int y, int z)
-    {
-        if(world.getBlockId(x, y + 1, z) != Blocks.COBBLE_NETHERRACK.id())
-        {
-            return false;
-        }
-        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Blocks.COBBLE_NETHERRACK.id())
-        {
-            return false;
-        }
-        int l = 0;
-        if(world.getBlockId(x - 1, y, z) == Blocks.COBBLE_NETHERRACK.id())
-        {
-            l++;
-        }
-        if(world.getBlockId(x + 1, y, z) == Blocks.COBBLE_NETHERRACK.id())
-        {
-            l++;
-        }
-        if(world.getBlockId(x, y, z - 1) == Blocks.COBBLE_NETHERRACK.id())
-        {
-            l++;
-        }
-        if(world.getBlockId(x, y, z + 1) == Blocks.COBBLE_NETHERRACK.id())
-        {
-            l++;
-        }
-        if(world.getBlockId(x, y - 1, z) == Blocks.COBBLE_NETHERRACK.id())
-        {
-            l++;
-        }
-        int i1 = 0;
-        if(world.isAirBlock(x - 1, y, z))
-        {
-            i1++;
-        }
-        if(world.isAirBlock(x + 1, y, z))
-        {
-            i1++;
-        }
-        if(world.isAirBlock(x, y, z - 1))
-        {
-            i1++;
-        }
-        if(world.isAirBlock(x, y, z + 1))
-        {
-            i1++;
-        }
-        if(world.isAirBlock(x, y - 1, z))
-        {
-            i1++;
-        }
-        if(l == 4 && i1 == 1)
-        {
-            world.setBlockWithNotify(x, y, z, blockId);
-            world.scheduledUpdatesAreImmediate = true;
-            Blocks.blocksList[blockId].updateTick(world, x, y, z, random, false);
-            world.scheduledUpdatesAreImmediate = false;
-        }
-        return true;
-    }
-}
+	@MethodParametersAnnotation(names = {"blockId"})
+	public WorldFeatureNetherSpring(int blockId) {
+		this.blockId = blockId;
+	}
+
+	@Override
+	public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+		TilePos upPos = new TilePos(tilePos).up();
+
+		if (world.getBlockType(upPos).hasTag(BlockTags.NETHER_SURFACE_BLOCK)) {
+			return false;
+		} else if (!world.isAirBlock(tilePos) && world.getBlockType(tilePos).hasTag(BlockTags.NETHER_SURFACE_BLOCK)) {
+			return false;
+		} else {
+			int solidCount = 0;
+			int airCount = 0;
+
+			TilePos queryPos = new TilePos();
+			int[][] offsets = {{-1, 0, 0}, {1, 0, 0}, {0, 0, -1}, {0, 0, 1}, {0, -1, 0}};
+
+			for (int[] offset : offsets) {
+				queryPos.set(tilePos.x() + offset[0], tilePos.y() + offset[1], tilePos.z() + offset[2]);
+				if (world.getBlockType(queryPos).hasTag(BlockTags.NETHER_SURFACE_BLOCK)) {
+					solidCount++;
+				}
+				if (world.isAirBlock(queryPos)) {
+					airCount++;
+				}
+			}
+
+			if (solidCount == 4 && airCount == 1) {
+				if (this.blockId == Blocks.FLUID_ACID_STILL.id() || this.blockId == Blocks.FLUID_ACID_FLOWING.id()) {
+					if (random.nextInt(50) == 0 && world.isAirBlock(upPos)) {
+						world.setBlockTypeNotify(tilePos, Blocks.GLOWSTONE);
+						world.setBlockTypeNotify(upPos, Blocks.FIRE_SULFURIC);
+					}
+				} else {
+					Block<?> block = Blocks.blocksList[this.blockId];
+					world.setBlockTypeNotify(tilePos, block);
+
+					world.scheduledUpdatesAreImmediate = true;
+					block.updateTick(world, tilePos, random, false);
+					world.scheduledUpdatesAreImmediate = false;
+				}
+			}
+
+			return true;
+		}
+	}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
index 138b96771..908bebe16 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
@@ -1,44 +1,51 @@
 package net.minecraft.core.world.generate.feature;
 
 import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class WorldFeatureOre extends WorldFeature
-{
-    private int minableBlockId;
-    private int numberOfBlocks;
+public class WorldFeatureOre implements WorldFeatureInterface {
+    private final int minableBlockId;
+    private final int numberOfBlocks;
     private final Int2IntArrayMap variantMap;
     @MethodParametersAnnotation(names = {"blockId", "numberOfBlocks"})
-    public WorldFeatureOre(int blockId, int numberOfBlocks)
-    {
-        minableBlockId = blockId;
+    public WorldFeatureOre(int blockId, int numberOfBlocks) {
+        this.minableBlockId = blockId;
         this.numberOfBlocks = numberOfBlocks;
         this.variantMap = null;
     }
     @MethodParametersAnnotation(names = {"blockId", "numberOfBlocks", "variantMap"})
-    public WorldFeatureOre(@NotNull Int2IntArrayMap variantMap, int numberOfBlocks)
-    {
+    public WorldFeatureOre(@NotNull Int2IntArrayMap variantMap, int numberOfBlocks) {
+        this.minableBlockId = 0;
         this.numberOfBlocks = numberOfBlocks;
         this.variantMap = variantMap;
     }
 
     @Override
-	public boolean place(World world, Random random, int xStart, int yStart, int zStart)
-    {
+    public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
         float f = random.nextFloat() * MathHelper.PI;
+
+        int xStart = tilePos.x();
+        int yStart = tilePos.y();
+        int zStart = tilePos.z();
+
         double xMax = (float)(xStart + 8) + MathHelper.sin(f) * (float)numberOfBlocks / 8F;
         double xMin = (float)(xStart + 8) - MathHelper.sin(f) * (float)numberOfBlocks / 8F;
         double zMax = (float)(zStart + 8) + MathHelper.cos(f) * (float)numberOfBlocks / 8F;
         double zMin = (float)(zStart + 8) - MathHelper.cos(f) * (float)numberOfBlocks / 8F;
         double yMax = yStart + random.nextInt(3) + 2;
         double yMin = yStart - random.nextInt(3) + 2;
-        for(int l = 0; l <= numberOfBlocks; l++)
-        {
+
+        TilePos queryPos = new TilePos();
+
+        for(int l = 0; l <= numberOfBlocks; l++) {
             double d6 = xMax + (xMin - xMax) * (double)l / (double)numberOfBlocks;
             double d7 = yMax + (yMin - yMax) * (double)l / (double)numberOfBlocks;
             double d8 = zMax + (zMin - zMax) * (double)l / (double)numberOfBlocks;
@@ -51,52 +58,45 @@ public class WorldFeatureOre extends WorldFeature
             int xVeinEnd = MathHelper.floor(d6 + d10 / 2D);
             int yVeinEnd = MathHelper.floor(d7 + d11 / 2D);
             int zVeinEnd = MathHelper.floor(d8 + d10 / 2D);
-            for(int x = xVeinStart; x <= xVeinEnd; x++)
-            {
+
+            for(int x = xVeinStart; x <= xVeinEnd; x++) {
                 double d12 = (((double)x + 0.5D) - d6) / (d10 / 2D);
-                if(d12 * d12 >= 1.0D)
-                {
+                if(d12 * d12 >= 1.0D) {
                     continue;
                 }
-                for(int y = yVeinStart; y <= yVeinEnd; y++)
-                {
+                for(int y = yVeinStart; y <= yVeinEnd; y++) {
                     double d13 = (((double)y + 0.5D) - d7) / (d11 / 2D);
-                    if(d12 * d12 + d13 * d13 >= 1.0D)
-                    {
+                    if(d12 * d12 + d13 * d13 >= 1.0D) {
                         continue;
                     }
-                    for(int z = zVeinStart; z <= zVeinEnd; z++)
-                    {
+                    for(int z = zVeinStart; z <= zVeinEnd; z++) {
                         double d14 = (((double)z + 0.5D) - d8) / (d10 / 2D);
-                        if(d12 * d12 + d13 * d13 + d14 * d14 < 1.0D)
-                        {
-                        	if (variantMap != null)
-                        	{
-                                int blockId = world.getBlockId(x, y, z);
-                                if (blockId <= 0) continue;
-                                if (variantMap.containsKey(blockId)){
-                                    world.setBlock(x, y, z, variantMap.get(blockId));
+                        if(d12 * d12 + d13 * d13 + d14 * d14 < 1.0D) {
+
+                            queryPos.set(x, y, z);
+                            Block<?> currentBlock = world.getBlockType(queryPos);
+
+                            if (currentBlock == Blocks.AIR) continue;
+
+                            int id = currentBlock.id();
+
+                            if (variantMap != null) {
+                                if (variantMap.containsKey(id)){
+                                    world.setBlockType(queryPos, Blocks.blocksList[variantMap.get(id)]);
+                                }
+                            } else {
+                                if (id == Blocks.STONE.id() || id == Blocks.COBBLE_NETHERRACK.id() ||
+                                    id == Blocks.BASALT.id() || id == Blocks.LIMESTONE.id() ||
+                                    id == Blocks.GRANITE.id()) {
+
+                                    world.setBlockType(queryPos, Blocks.blocksList[minableBlockId]);
                                 }
-                        	}
-                        	else
-                        	{
-                        		int id = world.getBlockId(x, y, z);
-                        		if (id == Blocks.STONE.id() || id == Blocks.COBBLE_NETHERRACK.id() ||
-                        				id == Blocks.BASALT.id() || id == Blocks.LIMESTONE.id() ||
-                        				id == Blocks.GRANITE.id())
-                        		{
-                        			world.setBlock(x, y, z, minableBlockId);
-                        		}
-                        	}
+                            }
                         }
                     }
-
                 }
-
             }
-
         }
-
         return true;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePerlinVein.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePerlinVein.java
new file mode 100644
index 000000000..a160d7226
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePerlinVein.java
@@ -0,0 +1,72 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class WorldFeaturePerlinVein implements WorldFeatureInterface {
+    private final Block<?> placeBlock;
+    private final Block<?> targetBlock;
+    private ImprovedPerlinNoise noiseGen;
+    private final double scale;
+    private final double thickness;
+
+    public WorldFeaturePerlinVein(Block<?> placeBlock, Block<?> targetBlock, double scale, double thickness) {
+        this.placeBlock = placeBlock;
+        this.targetBlock = targetBlock;
+        this.scale = scale;
+        this.thickness = thickness;
+    }
+
+    @Override
+    public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+        if (this.noiseGen == null) {
+            this.noiseGen = new ImprovedPerlinNoise(new Random(world.getRandomSeed() + this.placeBlock.id()));
+        }
+
+        int startX = tilePos.x();
+        int startZ = tilePos.z();
+        int maxY = world.getWorldType().getMaxY(world);
+        int minY = world.getWorldType().getMinY(world);
+        int ySize = maxY - minY;
+        if (ySize <= 0) {
+            return false;
+        }
+
+        // Single bulk noise sample for the full chunk column instead of per-block.
+        double[] noiseRegion = this.noiseGen.getRegion(null, startX, minY, startZ, 16, ySize, 16, this.scale, this.scale, this.scale);
+
+        boolean placedAny = false;
+        TilePos queryPos = new TilePos();
+
+        for (int xi = 0; xi < 16; xi++) {
+            int worldX = startX + xi;
+            int xBase = xi * 16 * ySize;
+            for (int zi = 0; zi < 16; zi++) {
+                int worldZ = startZ + zi;
+                int zBase = xBase + zi * ySize;
+                for (int yi = 0; yi < ySize; yi++) {
+                    double noiseVal = noiseRegion[zBase + yi];
+                    if (Math.abs(noiseVal) > this.thickness) {
+                        continue;
+                    }
+
+                    queryPos.set(worldX, minY + yi, worldZ);
+                    if (world.getBlockType(queryPos) != this.targetBlock) {
+                        continue;
+                    }
+
+                    world.setBlockType(queryPos, this.placeBlock);
+                    placedAny = true;
+                }
+            }
+        }
+
+        return placedAny;
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRoofSpire.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRoofSpire.java
new file mode 100644
index 000000000..d60ce0ab1
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRoofSpire.java
@@ -0,0 +1,74 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import org.joml.Vector3i;
+
+import java.util.Random;
+
+public class WorldFeatureRoofSpire extends WorldFeature {
+	private final Block<?> boulderBlock;
+
+	public WorldFeatureRoofSpire(Block<?> boulderBlock) {
+		this.boulderBlock = boulderBlock;
+	}
+
+	public boolean place(World world, Random random, int x, int y, int z) {
+		TilePos pos = new TilePos(x, y, z);
+
+		while (world.isAirBlock(pos) && pos.y < 245) {
+			pos.up();
+		}
+
+		if (this.hasSpace(world, pos.x, pos.y, pos.z)) {
+			Vector3i highestOffset = new Vector3i(0, 0, 0);
+			TilePos centerPos = new TilePos(pos.x, pos.y, pos.z);
+			TilePos queryPos = new TilePos();
+
+			for (int x1 = 0; x1 < 2; ++x1) {
+				for (int z1 = 0; z1 < 2; ++z1) {
+					int height = random.nextInt(6) + 4;
+					if (height > highestOffset.y) {
+						highestOffset.set(x1, height, z1);
+					}
+
+					for (int y1 = 0; y1 < height; ++y1) {
+						centerPos.add(x1, -y1, z1, queryPos);
+
+						Block<?> currentBlock = world.getBlockType(queryPos);
+
+						if (currentBlock != Blocks.BEDROCK) {
+							world.setBlockType(queryPos, boulderBlock);
+						}
+					}
+				}
+			}
+
+			for (int y1 = 0; y1 < 2; ++y1) {
+				centerPos.add(highestOffset.x, -(highestOffset.y + y1), highestOffset.z, queryPos);
+				world.setBlockType(queryPos, boulderBlock);
+			}
+		}
+
+		return true;
+	}
+
+	private boolean hasSpace(World world, int xc, int y, int zc) {
+		TilePos queryPos = new TilePos();
+
+		for (queryPos.y = y - 3; queryPos.y > y - 9; --queryPos.y) {
+			for (queryPos.x = xc - 3; queryPos.x < xc + 3; ++queryPos.x) {
+				for (queryPos.z = zc - 3; queryPos.z < zc + 3; ++queryPos.z) {
+					if (!world.isAirBlock(queryPos) && !world.getBlockType(queryPos).hasTag(BlockTags.NETHER_SURFACE_BLOCK)) {
+						return false;
+					}
+				}
+			}
+		}
+
+		return true;
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassCrystalline.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassCrystalline.java
new file mode 100644
index 000000000..c47fd7f3b
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassCrystalline.java
@@ -0,0 +1,164 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.voxelizer.ConvexShapeVoxelizer;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Matrix4f;
+import org.joml.Vector3f;
+
+import java.util.Objects;
+import java.util.Random;
+
+public class WorldFeatureRubyglassCrystalline implements WorldFeatureInterface {
+	private static final float BASE_PCTG = 0.5F;
+	private final boolean isCeiling;
+	private final int minHeight;
+	private final int heightMod;
+
+	public WorldFeatureRubyglassCrystalline(boolean isCeiling, int minHeight, int heightMod) {
+		this.isCeiling = isCeiling;
+		this.minHeight = minHeight;
+		this.heightMod = heightMod;
+	}
+
+	public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+		TilePos ti = new TilePos(tilePos.x() + random.nextInt(2) - random.nextInt(2), tilePos.y(), tilePos.z() + random.nextInt(2) - random.nextInt(2));
+		int floorY = -1;
+		int checksForGround = 0;
+		boolean foundGround = false;
+		boolean canGenerate = false;
+		int groundDepth = 0;
+
+		while (true) {
+			if (this.isCeiling) {
+				++ti.y;
+			} else {
+				--ti.y;
+			}
+
+			if (checksForGround > 64 || ti.y < 0 || ti.y >= world.getHeightBlocks()) {
+				break;
+			}
+
+			Block<?> block = world.getBlockType(ti);
+			if (!foundGround) {
+				if (block == Blocks.COBBLE_NETHERRACK) {
+					floorY = ti.y;
+					foundGround = true;
+				}
+			} else {
+				++groundDepth;
+				if (block != Blocks.COBBLE_NETHERRACK) {
+					break;
+				}
+
+				if (groundDepth >= 6) {
+					canGenerate = true;
+					break;
+				}
+			}
+
+			++checksForGround;
+		}
+
+		Block<?> block = world.getBlockType(ti);
+		if (canGenerate && (block == Blocks.COBBLE_NETHERRACK || block == Blocks.RUBYGLASS_CRYSTAL || block == Blocks.SOULSAND)) {
+			if (this.isCeiling) {
+				++floorY;
+			} else {
+				--floorY;
+			}
+
+			this.placeCrystal(world, random, new TilePos(ti.x, floorY, ti.z));
+			return true;
+		} else {
+			return false;
+		}
+	}
+
+	private float randomOffset(int length, @NotNull Random random) {
+		int base = length / 16;
+		return random.nextFloat() * (float) base;
+	}
+
+	private void placeCrystal(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+		float r = random.nextFloat();
+		int length = this.minHeight + MathHelper.floor(Math.pow(r, 4.0F) * (double) this.heightMod);
+		int base = length / 4;
+		float rx = 0.0F;
+		float ry = 0.0F;
+		Block<?> column = Blocks.RUBYGLASS_COLUMN;
+		Block<?> bed = Blocks.COBBLE_NETHERRACK_CRYSTALLINE;
+		Block<?> node = Blocks.RUBYGLASS_NODE;
+		TilePos ti = new TilePos(tilePos);
+		ti.y = this.isCeiling ? ti.y + base / 2 : ti.y - base / 2;
+		if (this.hasSpace(world, ti, base)) {
+			float minBase = -((float) base / 2.0F);
+			float maxBase = (float) base / 2.0F;
+			float randX = this.randomOffset(length, random);
+			float randZ = this.randomOffset(length, random);
+			Vector3f[] pts = new Vector3f[]{new Vector3f(minBase - randX, 0.0F, minBase - randZ), new Vector3f(maxBase + randX, 0.0F, minBase - randZ), new Vector3f(minBase - randX, 0.0F, maxBase + randZ), new Vector3f(maxBase + randX, 0.0F, maxBase + randZ), new Vector3f(minBase - randX, (float) length, minBase - randZ), new Vector3f(maxBase + randX, (float) length, minBase - randZ), new Vector3f(minBase - randX, (float) length, maxBase + randZ), new Vector3f(maxBase + randX, (float) length, maxBase + randZ), new Vector3f(0.0F, (float) length + maxBase * 4.0F * (random.nextFloat() * 0.5F + 0.5F), 0.0F)};
+			if (this.isCeiling) {
+				rx = (float) Math.PI;
+			}
+
+			rx += (float) ((random.nextDouble() - (double) 0.5F) * (Math.PI / 2D)) * 0.8F;
+			ry += (float) (random.nextDouble() * (double) 2.0F * Math.PI);
+			Matrix4f matrix = Objects.requireNonNull((new Matrix4f()).rotateY(ry).rotateX(rx));
+			int[][] faces = new int[][]{{0, 1, 3}, {0, 1, 5}, {1, 3, 7}, {3, 2, 6}, {2, 0, 4}, {4, 5, 8}, {5, 7, 8}, {7, 6, 8}, {6, 4, 8}};
+			ConvexShapeVoxelizer voxelizer = new ConvexShapeVoxelizer(pts, faces, matrix, (worldPos, replacing, faceDistances) -> {
+				if (replacing == Blocks.BEDROCK) {
+					return null;
+				} else {
+					boolean ore = random.nextInt(100) == 0;
+					boolean generateBed = false;
+					float distancePctg = faceDistances[0] / (float) length;
+					if (distancePctg < 0.5F) {
+						float innerDistancePctg = distancePctg / 0.5F;
+						if ((double) innerDistancePctg < (double) random.nextFloat() * (double) 0.75F) {
+							generateBed = true;
+						}
+					}
+
+					float minDistToSide = 10.0F;
+
+					for (int i = 1; i <= 4; ++i) {
+						minDistToSide = Math.min(faceDistances[i], minDistToSide);
+					}
+
+					float distFromCenter = maxBase - minDistToSide;
+					float distanceToCenterPctg = minDistToSide / maxBase;
+					if ((double) distFromCenter > (double) 0.5F) {
+						return generateBed ? bed : (ore ? node : column);
+					} else {
+						float centerNoise = (float) Math.sin((double) distanceToCenterPctg * Math.PI * (double) 3.0F) * 0.5F;
+						float finalNoise = random.nextFloat() + centerNoise;
+						return (double) finalNoise > (double) 0.5F ? node : column;
+					}
+				}
+			});
+			voxelizer.voxelize(world, ti);
+		}
+	}
+
+	private boolean hasSpace(@NotNull World world, @NotNull TilePosc tilePos, int base) {
+		TilePos ti = new TilePos();
+
+		for (ti.y = tilePos.y(); ti.y < tilePos.y() + base; ++ti.y) {
+			for (ti.x = tilePos.x() - base; ti.x < tilePos.x() + base; ++ti.x) {
+				for (ti.z = tilePos.z() - base; ti.z < tilePos.z() + base; ++ti.z) {
+					if (world.getBlockType(ti) == Blocks.RUBYGLASS_COLUMN) {
+						return false;
+					}
+				}
+			}
+		}
+
+		return true;
+	}
+}
